#define VER 5
#define VERNAME "Modbus"

byte soundpin = 255;
byte gpio0format = 1;

/*
  * 
  * 
  * 
  * 
  * krutaya doka:  http://arduino.esp8266.com/versions/1.6.5-1160-gef26c5f/doc/reference.html
  Функция ESP.deepSleep(microseconds, mode) режим глубокого сна. Для аргумента mode WAKE_RF_DEFAULT, WAKE_RFCAL, WAKE_NO_RFCAL и WAKE_RF_DISABLED.
  Контакт GPIO16 должен быть привязан к RST – чтобы вывести чип из режима глубокого сна.
  ADC_MODE(ADC_VCC); в самом начале
  stream.findUntil(char target, terminal)
*/

#include "FS.h"

#include <ESP8266WiFi.h>
// #include <ESP8266WiFiMulti.h>
#include <ESP8266WebServer.h>
#include <DNSServer.h>
#include <Servo.h>

#include <ESP8266HTTPClient.h>
#include <ESP8266httpUpdate.h>

#include <ESP8266mDNS.h>

#include <Ticker.h>  //Ticker Library

#include <time.h> // дату чтобы конвертировать из UnixTime


//---------------- Dallas

/* DS18B20 Temperature Sensor */
#include <OneWire.h>
#include <DallasTemperature.h>

#define WIREPIN 4

// OneWire * oneWire = new OneWire(WIREPIN);
OneWire oneWire(WIREPIN);
DallasTemperature DS18B20(&oneWire);
// DallasTemperature DS18B20 = new DallasTemperature(&oneWire);

// MQTT

#include <PubSubClient.h>
WiFiClient MQTT_espClient;
PubSubClient client(MQTT_espClient);
uint8_t MQTT=0;
// SSL Port  22399
// Websockets Port (TLS only)  32399

// Функция получения данных от сервера
void MQTT_callback(char* topic, byte* payload, unsigned int l) {
  String s=""; for(int i=0; i<l; i++) s+=(char)payload[i];
  LOG("MQTT get ["+String(topic)+"]: "+s);
  CFSET("MQTT_TOPIC",String(topic));
  CFSET("MQTT_DATA",s);
  MOTO("/MQTT");
}


/*
void MQTT_callback(const MQTT::Publish& pub) {
    String s = pub.payload_string();
    LOG("MQTT: "+pub.topic()+" => "+s);
    if(String(pub.topic()) == "test/led") LOG("topic = test/led !!!");
}
*/

// ===== modbus ===
#include "Modbus.h"
#include "ModbusIP_ESP8266.h"
ModbusIP MODBUS;
byte MODBUSstart=0;
//char MODBUSread[12]={0xAA};
// ===== modbus ===


//   randomSeed(micros());
// PubSubClient client(wclient, mqtt_server, mqtt_port);
// /MQTT

// RFID: 
#include <SPI.h>

// wiring the MFRC522 to ESP8266 (ESP-12)
// RST     = GPIO5
// SDA(SS) = GPIO4
// MOSI    = GPIO13
// MISO    = GPIO12
// SCK     = GPIO14
// GND     = GND
// 3.3V    = 3.3V
#define RST_PIN 5
#define SS_PIN 4

#include <MFRC522.h>
MFRC522 mfrc522(SS_PIN,RST_PIN);

byte NFC_init=0;

#include "chuk.c"


//================== mp3 ==================
#include "AudioFileSourceSPIFFS.h"
#include "AudioFileSourceID3.h"
#include "AudioGeneratorMP3.h"
#include "AudioOutputI2SNoDAC.h"
AudioGeneratorMP3 *mp3;
AudioFileSourceSPIFFS *mp3file;
AudioOutputI2SNoDAC *mp3out;
AudioFileSourceID3 *mp3id3;

/* // mp3 web
#include "AudioFileSourceICYStream.h"
#include "AudioFileSourceBuffer.h"
AudioFileSourceICYStream *mp3fileWEB;
AudioFileSourceBuffer *mp3buff;
*/

byte PlayMP3=0;

// Called when a metadata event occurs (i.e. an ID3 tag, an ICY block, etc.
void MDCallback(void *cbData, const char *type, bool isUnicode, const char *string) {
  (void)cbData;
  Serial.printf("ID3 callback for: %s = '", type);
  if (isUnicode) { string += 2; }
  while (*string) { char a = *(string++); if(isUnicode) string++; Serial.printf("%c", a); }
  Serial.printf("'\n");
  Serial.flush();
}

/*
// Called when a metadata event occurs (i.e. an ID3 tag, an ICY block, etc.
void MDCallbackWEB(void *cbData, const char *type, bool isUnicode, const char *string) {
  const char *ptr = reinterpret_cast<const char *>(cbData);
  (void) isUnicode; // Punt this ball for now
  // Note that the type and string may be in PROGMEM, so copy them to RAM for printf
  char s1[32], s2[64];
  strncpy_P(s1, type, sizeof(s1));
  s1[sizeof(s1)-1]=0;
  strncpy_P(s2, string, sizeof(s2));
  s2[sizeof(s2)-1]=0;
  Serial.printf("METADATA(%s) '%s' = '%s'\n", ptr, s1, s2);
  Serial.flush();
}
*/

// Called when there's a warning or error (like a buffer underflow or decode hiccup)
void StatusCallback(void *cbData, int code, const char *string) {
  const char *ptr = reinterpret_cast<const char *>(cbData);
  // Note that the string may be in PROGMEM, so copy it to RAM for printf
  char s1[64];
  strncpy_P(s1, string, sizeof(s1));
  s1[sizeof(s1)-1]=0;
  Serial.printf("STATUS(%s) '%d' = '%s'\n", ptr, code, s1);
  Serial.flush();
}













//=========================================

File fsUploadFile;
String UploadResult="";

const String DefaultConfig=
"set soft = default2\n"
"set autoupdate = yes\n"
"set server_update = http://lleo.me/ESP8266/index.php?ip={ip}&chip={chip}&soft={soft}\n"
"#set AP_name = ESP-HELP\n"
"#set AP_password =\n"
"set WIFI_MY = 1"
"WIFI.disconnect YES"
"WIFI.APdisconnect YES"
"usleep 500"
"WIFI.autoconnect YES"
"WIFI.autoreconnect YES"
"WIFI.persistent FALSE"
"WIFI.mode STA"
"WIFI.dns NO"
"WIFI test password"
"WIFI.waitconnect"
"if.!WIFI {"
"    WIFI.mode AP"
"    WIFI.hostname ESP-HELP"
"    WIFI.AP ESP-HELP"
"    WIFI.dns"
"}"
"\n"
"pinmode 2 OUTPUT\n"
"loop 1 10 upgrade\n";

// static const char DefaultINDEX[] PROGMEM=
const String DefaultINDEX=
"<html><body><h1>Connect your WiFi for first time SPIFFS install</h1><p><form method='GET' action='/FM'>"
     "<input type='hidden' name='a' value='WIFIconn1'>"
     "<br>Login: <input type='text' name='net'>"
     "<br>Password: <input type='text' name='pass'>"
     "<br><input type='submit' value='Go'></form></body></html>";

// static const char InfoTemplate[] PROGMEM=
const String InfoTemplate=
      "\nsoft: {soft} chip: {chip}"
      "\nCpuFreq: {CpuFreq} MHz FreeHeap: {FreeHeap} FlashChipRealSize: {FlashChipRealSize}"
      "\n ip_ssid: {ip_ssid}"
      "\n ip: {ip}"
      "\nmdns: http://{mdns}.local"
      "\n softAPIP: {softAPIP}"  
      "\n AP_name: {AP_name}"
      "\n AP_password: {AP_password}"
      "\n "
      "\nResetReason: {ResetReason}"
;


#define DEFAULTPORT 80 // отвечающий порт вебки

String EchoMOTO=""; // строка для вывода инфы в Аякс

// bool IF=1;
// byte ThisLOOP=255;

#define NLOOP 50 // максимальное число таймеров 100
#define NSET 50 // максимальное число переменных 400
#define NSERV 12 // максимальное число серв 0..11 12

struct JeniferServos { // шаблон серв
  uint8_t pin=255;
  Servo serv;
}; JeniferServos Servos[NSERV];

struct JeniferLoopes { // шаблон таймера
  uint32_t count=0;
  uint32_t value=0;
  uint16_t one=0; // число повторов (0 - повторять вечно)
  String file="";
}; JeniferLoopes Loopes[NLOOP]; // volatile не работает почему-то, может и не надо

struct JeniferSettes { // шаблон базы переменных
  String n="";
  String v="";
}; JeniferSettes Settes[NSET];

Ticker tim;

unsigned int tim_motor_detach=0;

unsigned long UnixTime=0;
byte TimeHour=0;
byte TimeMinute=0;
byte TimeSecond=0;

void tim_engine() { // процедура ежесекундного таймера

  UnixTime++;
  if(++TimeSecond >=60) { TimeSecond=0; if(++TimeMinute >=60) { TimeMinute=0; if(++TimeHour >=24) TimeHour=0; } }

  for(uint8_t i=0;i<NLOOP;i++) {
    if(Loopes[i].value==0) continue; // нет такого цикла
    if(Loopes[i].count>=Loopes[i].value) continue; // уже пошёл на выполнение
    Loopes[i].count++;
  }

  if(tim_motor_detach) {
    if(! --tim_motor_detach) {
      for(uint8_t n=0;n<NSERV;n++) {   if(Servos[n].pin!=255) ServDetach(n);    }
    }
  }
}


#define NBUF 64 // максимальный размер буфера должен быть строго кратен степени двойки, напр. 64, 128, 256, 512

struct BufLoopes { // шаблон таймера
  uint16_t kn=0;
  uint16_t A0=0;
}; BufLoopes Buf[NBUF];

byte bufn=NBUF-1;

Ticker timpin;

uint16_t MOTORSTOP = 0;

byte timstarted=0;

#define KBIT0  0b0000000000100000
#define KBIT1  0b0000000001000000
#define KBIT2  0b0000000010000000
#define KBIT3  0b0000000100000000
#define KBIT4  0b0000001000000000
#define KBIT5  0b0000010000000000
#define KBIT12 0b0000100000000000
#define KBIT13 0b0001000000000000
#define KBIT14 0b0010000000000000
#define KBIT15 0b0100000000000000
#define KBIT16 0b1000000000000000

void pinlog_engine() { // процедура таймера-следилки за пинами
  bufn = (++bufn) & (NBUF-1);

  Serial.print(" ("+String(bufn)+") ");
  
  uint16_t c=analogRead(A0);
  if(MOTORSTOP && c>MOTORSTOP) { Serial.println("\n\n\t\t\t### STOP: ["+String(c)+"] > ["+String(MOTORSTOP)+"]"); 
  DOMOTO("/MOTOR-STOP");
  }
  Buf[bufn].A0=c;
  Buf[bufn].kn=FLT(c)
    +(digitalRead(0)?KBIT0:0)
    +(digitalRead(1)?KBIT1:0)  
    +(digitalRead(2)?KBIT2:0) 
    +(digitalRead(3)?KBIT3:0)
    +(digitalRead(4)?KBIT4:0)
    +(digitalRead(5)?KBIT5:0)  
    +(digitalRead(12)?KBIT12:0)
    +(digitalRead(13)?KBIT13:0)
    +(digitalRead(14)?KBIT14:0)  
    +(digitalRead(15)?KBIT15:0) 
    +(digitalRead(16)?KBIT16:0);
}

// === работа с сервами ===
void ServDetach(uint8_t n) { if(Servos[n].serv.attached()) Servos[n].serv.detach(); }
void ServAttach(uint8_t n, uint8_t i) { if(!Servos[n].serv.attached()) { Servos[n].pin=i; Servos[n].serv.attach(i); tim_motor_detach=2; } }
void ServWrite(uint8_t n, int i) { if(!Servos[n].serv.attached()) Servos[n].serv.attach(Servos[n].pin); tim_motor_detach=2; Servos[n].serv.write(i); }
// ========================

// ADC_MODE(ADC_VCC);

byte DNSstart=0;
DNSServer DNS;
ESP8266WebServer WEB( DEFAULTPORT );

void setup() {
  Serial.begin(115200);
  Serial.println(F("\n\n\n\n\n\t\t\t### Restart ###"));
  SPIFFS.begin(); // флеш-память
  tim.attach(1,tim_engine); // таймер на 1 sec

  audioLogger = &Serial;
  mp3 = new AudioGeneratorMP3();

 const char * headerkeys[] = {"User-Agent","Cookie"} ;
 size_t headerkeyssize = sizeof(headerkeys)/sizeof(char*);

 WEB.collectHeaders(headerkeys, headerkeyssize );

  // WEB.on("/format",HTTP_GET,[](){ SPIFFS.format(); });
  

// File Manager System

WEB.on("/upload", HTTP_POST, []() { otprav(UploadResult); }, handleFileUpload);
WEB.on("/dir",HTTP_GET,[](){ if(!AD(0)) return; otprav(REPER("{dir}")); });
WEB.on("/info",HTTP_GET,[](){ if(!AD(0)) return; otprav(FullInfo()); });
WEB.on("/FM",HTTP_GET,[](){ String a=RE("a"); Serial.print("\nFM a="+a);

// разрешено всем

if(a=="login") { if(CF("password")=="" || RE("password")!=CF("password")) otprav(""); otprav(CF("passhash")); }
if(a=="loop") { byte n=RE0("n"); if(n>=NLOOP || !Loopes[n].value) otprav(""); otprav(String(Loopes[n].value-Loopes[n].count)); return; }

if(a=="WIFIconn1" && CF("AP_name")=="ESP-HELP") { // аварийная установка сети
    Serial.println("========> Set network: ["+RE("net")+"] password: ["+RE("pass")+"]");
    savefile("wifi_last.txt",RE("net")+"\n"+RE("pass"));
    otprav("Reboot...");
    ESP.restart();
}

// остальное запрещено!
if(!AD(1)) return;

// if(a=="Info") { return otprav("idie(toTable('System Info',\""+njs(FullInfo())+"\"))"); }

if(a=="WIFIconn") {
  String net=RE("net");
  String pass=RE("pass");

Serial.println("========> WIFIconn`"+net+"`");
  
  String s="clean('idie'); idie('Reconnect to "+net+"');";
  otprav(s);
  savefile("wifi_last.txt",net+"\n"+pass);
  if(WIFItryConnect(net,pass)) { Serial.println("========> CONNECTED to `"+net+"`"); return; }

// WIFIinit()
// WiFi.disconnect(true);
// delay(1000);
  
  return idip("Error: Net: ["+net+"] / ["+pass+"]");
}

if(a=="WiFi") {
  int n=WiFi.scanNetworks();
  if(n == 0) return otprav("salert('No Networks found',3000);");
  
  String s=""; for(int i=0; i<n; ++i) {
      s+="\n"+String(i+1)+": "+( WiFi.encryptionType(i) == ENC_TYPE_NONE ? " &nbsp;&nbsp; " : "<i class=e_zamok></i>" )+"&nbsp;<div class=ll onclick='WIFIconn"+( WiFi.encryptionType(i) == ENC_TYPE_NONE ? "" : "p" )+"(this.innerHTML)'>"+WiFi.SSID(i)+"</div> ("+WiFi.RSSI(i)+")";
  }
  return otprav("idie(toTable('"+String(n)+" networks found',\""+njs(s)+"\"))");
}

if(a=="Restart") { otprav("salert('Reboot... <img src=ajaxm.gif>',10000); setTimeout('document.location.reload(true)',3000);"); return ESP.restart(); }
if(a=="Upgrade") { return otprav("salert('Upgrade: "+String(UpgradeALL()?"OK":"ERROR")+"',3000)"); }

String file=RE("file"); file.replace("..","");

if(a=="update"||a=="upgrade") {
    file.replace(".",""); if(file=="") file="firmware";
    upgrade_url(CF("server_update")+"&file="+file+".bin");
    return;
}

if(a=="save"){ return idie("Save: "+RE("file")); }

if(a=="del") { 
  delfile(file);
  return otprav("clean(\"file_"+h(file)+"\"); salert(\"Delete: "+h(file)+"\",1000);");
}
  
if(a=="upload") {
  String homeServer=CF("server_update");
  file=noSlash(file);
  String o="";
  if(file=="all.list") { Serial.println("========> UPLOAD LIST: ["+homeServer+file+"]");
      String s=file_get_contents(homeServer+file,5000); if(s=="" || s.startsWith("ERROR")) return otprav("salert(\"ERROR:<br>"+s+"\",2000);");
      int i; while(i>=0) { i=s.indexOf("\n"); if(i<0) break;
        String fu=s.substring(0,i);
        o+="<br>"+fu+" ";
        if(fu!="" && ! fu.endsWith(".bin") && fu!="all.list") o+=file_upload_binary_o(homeServer+(homeServer.indexOf("?")>=0 ? "&file=" : "")+fu,fu);
        s=s.substring(i+1);
      }
  } else {
      Serial.println("========> UPLOAD BINARY: ["+homeServer+file+"]");
      o+="<br>"+file+" "+file_upload_binary_o(homeServer+(homeServer.indexOf("?")>=0 ? "&file=" : "")+file,file);
  }
}

return idie("FM error: "+a);

});


//-------------


WEB.on("/",HTTP_POST,[](){
  Serial.println("\nCookie: ["+WEB.header("Cookie")+"]\n");
  if(!AD(1)) return;
  String s=WEB.arg("plain");
  Serial.println("AJAX-MOTO-POST: ["+s+"]");
  EchoMOTO=" "; MOTO(s); otprav(EchoMOTO.substring(1)); EchoMOTO="";
});

WEB.on("/MOTO",HTTP_GET,[](){
  if(!WEB.args() || !AD(1)) return;
  
  String s="";  
  if(WEB.args()==1 & WEB.argName(0)=="file") s=WEB.arg(0);
  else { for(uint8_t i=0;i<WEB.args();i++) { s+=String(WEB.argName(i)); if(WEB.arg(i)!="") s+="="+String(WEB.arg(i)); if(i < (WEB.args()-1)) s+="&"; }}
  s.replace("|",";");
 
  Serial.println("\nAJAX-MOTO: ["+s+"]");
  EchoMOTO=" "; MOTO(s); otprav(EchoMOTO.substring(1)); EchoMOTO="";
});


WEB.onNotFound([](){ String s=String(WEB.uri());

// if(WEB.hasHeader("Cookie")) Serial.println("\nFound cookie: ["+WEB.header("Cookie")+"] AD="+AD()+"\n");

  if(s.endsWith("/")) { s+="index.htm"; DOMOTO("play 4 M"); }
  s=noSlash(s);
  if(inList("/"+s,"stopspam.txt")) return WEBNAH();

//  String o = String( WEB.method() == HTTP_GET ?"GET":"POST") + ": "+s;
//  if(WEB.args()) { o += "\nArguments:\n"; for(uint8_t i=0;i<WEB.args();i++) o+=" "+String(WEB.argName(i))+": "+String(WEB.arg(i))+"\n"; }
//  if(WEB.hasHeader("Cookie")){ o += "\nFound cookie: ["+WEB.header("Cookie")+"]\n"; }
//  else o += "\n=== NO Cookie ===";
//  Serial.print(o+"\n");
 
  // файлы админа с приставкой "admin_"
  if( AD() && ( filewebsend("admin_"+s) || filewebsend("admin_"+s+".gz") ) ) return;
  if( filewebsend(s) || filewebsend(s+".gz") ) return;

  if(s=="index.htm") { WEB.send(200,"text/html",DefaultINDEX); return; }

  if(WiFi.isConnected()) return WEBNAH();
          
  String l="http://"+WiFi.softAPIP().toString()+"/";
  Serial.println("Redirect: "+l);
  WEB.sendHeader("Location",l);
  WEB.send(302,"text/plain","Moved Permanently");
});

  WEB.begin();

  // =============================
  MOTO(DefaultConfig); // запустить основную инициализацию
  MOTO("config.txt"); // запустить основную инициализацию

  if(CF("password")!="") CFSET("passhash",MD5(REPER(F("{password}/{chip}/{FlashChipId}"))));
  // Serial.println(FullInfo());

  if(CF("WIFI_MY")!="1") WIFIinit();

// =============================

  if(CF("mdns")=="") CF("mdns")="esp";
  if(MDNS.begin(CF("mdns"))) Serial.println(" * MDNS started: http://"+CF("mdns")+".local");

  if(gpio0format) { pinMode(0,INPUT); if(!digitalRead(0)) {  Serial.println("Format SPIFFS"); /*SPIFFS.format(); ESP.restart();*/ } }

} // конец void setup


void loop() {

  if(PlayMP3 && mp3->isRunning()) { if(!mp3->loop()) { mp3->stop(); PlayMP3=0; } } else {

  if(DNSstart) DNS.processNextRequest();
  if(MODBUSstart) MODBUS.task();
  
  WEB.handleClient();
  MDNS.update();
  if(MQTT && client.connected()) client.loop();
//  MQTT_reconnect();

  MOTO(CF("MAINLOOP"));

  for(uint8_t i=0;i<NLOOP;i++) {
    if(Loopes[i].value==0) continue; // цикл отсутствует
    if(Loopes[i].count>=Loopes[i].value) { // пришло время по секундам
      Loopes[i].count=0; // обнулить время по секундам
      // Serial.println("LOOP #"+String(i)+" MOTO: ["+Loopes[i].file+"]");
        
        if(MOTO(Loopes[i].file)=="stop") Loopes[i].value=0; // завершить выполнение и не повторять более
      
      if(Loopes[i].one!=0) { if(--Loopes[i].one == 0) Loopes[i].value=0; } // остановить
      break; // только одну за раз!
    }
  }

 }
}

// ====================================================================
String RE(String n) {
    if(!WEB.args()) return "";
    for(uint8_t i=0;i<WEB.args();i++) if(WEB.argName(i)==n) return WEB.arg(i);
    return "";
}

int RE0(String n) { return RE(n).toInt(); }

void WEBNAH() {
  WEB.sendHeader("Cache-Control","no-cache, no-store, must-revalidate");
  WEB.sendHeader("Pragma","no-cache");
  WEB.sendHeader("Expires","-1");
  WEB.send(404,"text/plain","404 Not Found");
}

bool is_file(String f) { return SPIFFS.exists(Slash(f)); }

bool file_rename(String f, String t) { f=Slash(f); t=Slash(t); int i; if(is_file(t)) { i=SPIFFS.remove(t); 
if(!i) LOG("\n============> RENAME ERROR 1: error delete ["+t+"]");
}

i=SPIFFS.rename(f,t);
if(!i) LOG("\n============> RENAME ERROR 2: ren ["+f+"] => ["+t+"]");
return i; }

bool filewebsend(String f) { f=Slash(f);
  if(!SPIFFS.exists(f) || (!AD() && inList(f,"stopweblist.txt")) ) return 0;
  File file = SPIFFS.open(f,"r"); if(!file) return 0;
  size_t sent = WEB.streamFile(file,getContentType(f));
  file.close();
  return 1;
}

String MD5file(String file) { file=Slash(file);
    if(!SPIFFS.exists(file)) return "";
    File f = SPIFFS.open(file,"r"); if(!f) return "";
    MD5Builder md5;
    md5.begin();
    md5.addStream(f,f.size()); // md5.add("Test333");
    md5.calculate();
    f.close();
    return md5.toString();
}

String MD5(String s) {
    MD5Builder md5;
    md5.begin();
    md5.add(s.c_str());
    md5.calculate();
    return md5.toString();
}

unsigned long filesize(String file) { file=Slash(file);
    if(!SPIFFS.exists(file)) return 0;
    File f=SPIFFS.open(file,"r"); if(!f) return 0;
    return (unsigned long)f.size();
}

String getContentType(String filename){
  if(WEB.hasArg("download")) return F("application/octet-stream");
  else if(filename.endsWith(".htm") || filename.endsWith(".html") ) return F("text/html; charset=utf-8");
  else if(filename.endsWith(".svg")) return F("image/svg+xml");
  else if(filename.endsWith(".css")) return F("text/css");
  else if(filename.endsWith(".js")) return F("application/javascript");
  else if(filename.endsWith(".png")) return F("image/png");
  else if(filename.endsWith(".gif")) return F("image/gif");
  else if(filename.endsWith(".jpg")) return F("image/jpeg");
  else if(filename.endsWith(".ico")) return F("image/x-icon");
  else if(filename.endsWith(".xml")) return F("text/xml");
  else if(filename.endsWith(".pdf")) return F("application/x-pdf");
  else if(filename.endsWith(".zip")) return F("application/x-zip");
  else if(filename.endsWith(".gz")) return F("application/x-gzip");
  return F("text/plain; charset=utf-8");
}

void idip(String s) { Serial.println("\nIDIE: "+s); idie(s); }
void idie(String s) { otprav("helps('idie',\""+njsn(s)+"\")"); }
void idie(String hm,String s) { otprav("helps('"+hm+"',\""+njsn(s)+"\")"); }

void otprav(String s) {
    WEB.sendHeader(F("Access-Control-Allow-Origin"),"*");
    WEB.sendHeader(F("Content-Type"),F("text/plain; charset=utf-8"));
    WEB.send(200,F("text/plain"),s);
}

String njsn(String s) { s.replace("\n",""); s.replace("\r",""); s.replace("\"","\\\""); return s; }
String njs(String s) { s.replace("\n","\\n");  s.replace("\r",""); s.replace("\"","\\\""); return s; }
String h(String s) { s.replace("<","&lt;"); s.replace(">","&gt;"); return s; } 

String FullInfo() { String s=REPERFILE("/info.txt"); if(s=="") s=REPER(InfoTemplate); return s; }

String REPERFILE(String url) { return REPER(getfile(url)); }

// REPER

// ====================================================================================
// ====================================================================================
// ====================================================================================

bool delfile(String file) { file=Slash(file);
  uint8_t i=SPIFFS.remove(file);
  Serial.println("Delete file: "+file+" "+(i?"OK":"ERROR"));
  return i;
}

String getfile(String file) { file=Slash(file);
  File f=SPIFFS.open(file,"r"); if(!f) return "";
  String s=f.readString();
  f.close();
  return s;
}

// bool savetextfile(String file, String s) { s.replace("\\n","\n"); return savefile(file,s); }
// bool savetextfile(String file, String s, char* mod) {  s.replace("\\n","\n"); return savefile(file,s,mod); }

bool savefile(String file, String s) { return savefile(file,s,"w"); }

bool savefile(String file, String s, char* mod) { file=Slash(file); // “r”, “w”, “a”, “r+”, “w+”, “a+”. 
  File f=SPIFFS.open(file,mod); if(!f) return 0;
  f.print(s);
  f.close();
  return 1;
}


String file_upload_binary_o(String url,String file) {
  int i=file_upload_binary(url,file);
  if(i!=0) return "<font color=red>ERROR #"+String(i)+"</font>";
  return "<font color=green>OK</font>";
}

int8_t file_upload_binary(String url,String file) { file=Slash(file); if(inList(file,"stoplist.txt")) return 0;

  // WEB.stop();

  int8_t res=0;
  HTTPClient http;
  http.setTimeout(5000);   
  http.begin(url.c_str());
  // Serial.println("File_UPLOAD_BINARY_contents: "+url+" ");
  int c = http.GET();
  if(c == HTTP_CODE_OK) {

        int lastms=millis();

        file=Slash(file);

        // https://github.com/esp8266/Arduino/blob/master/libraries/ESP8266HTTPClient/examples/StreamHttpClient/StreamHttpClient.ino
        
        File f=SPIFFS.open(file+".tmp","w"); if(!f) res=-3; else {

       int len = http.getSize();
        // create buffer for read
       uint8_t buff[128] = { 0 };

        // get tcp stream
        WiFiClient * stream = http.getStreamPtr();

        // read all data from server
        while ( (millis()-lastms) < 60000 && http.connected() && (len > 0 || len == -1)) {
         
          // get available data size
          size_t size = stream->available();
             
          if(size) { // Serial.print(".");
            // read up to 128 byte
            int c = stream->readBytes(buff, ((size > sizeof(buff)) ? sizeof(buff) : size));
            if(c<=0) { res=-4; ERR("Error reading!"); break; }
            // write it to f
            f.write(buff, c);
            if(len > 0) len -= c;
          }
          delay(5);
        }
    }
    f.close();
    if((millis()-lastms) >= 60000) { LOG("Error TO: mills:"+String(millis())+" lastms:"+String(lastms)+" TD="+String(millis()-lastms)); res=-5; }
    if(!res) file_rename(file+".tmp", file);

  } else { res=-1; Serial.printf("\terror #%d: %s\n", c, http.errorToString(c).c_str()); }

  http.end();
  // WEB.begin();
  return res;
}

String file_get_contents(String url) { return file_get_contents(url,3000); }

String file_get_contents(String url,uint16_t timeout) {
  if(!WiFi.isConnected()) return ""; // если нет подключения к сети
  
  HTTPClient http;
  http.setTimeout(timeout);
  http.begin(url.c_str());
  Serial.println("File_get_contents: ["+url+"] timeout="+String(timeout));
  int c = http.GET();
  String s="";
  if(c == HTTP_CODE_OK) s=http.getString();
  else Serial.printf("\terror #%d: %s (timeout=%d)\n", c, http.errorToString(c).c_str(),timeout);
  http.end();
  return s;
}

uint16_t jsearch(String S) { //   String S=s.substring(i);
  for(uint16_t zi=0,i=0;i<S.length();i++) { // Serial.print(S[i]);
    if(S[i]=='}') {  // Serial.print("@");
        if(!zi) return i;
        else zi--;
    } else if(S[i]=='{') { // Serial.print("!");
      zi++; }
  }
  Serial.println("ERROR ["+S+"]");
  return S.length();
}


String MOTO(String s) { if(s=="") return "";
  if(s.indexOf("\n")<0) s.replace(";","\n");

  s.replace("{ ","{\n");
  
  bool IF=0;
  int16_t i=0,j=0;
  String ANS="NO";
  String S="";
  String other="";
  String cmd="";
  
 // Serial.println("========================================= MOTO:\n"+s+"\n==========");
  
  while(i<s.length()) { yield();
        
        j=s.indexOf("\n",i);  // Serial.println("i="+String(i)+" j="+String(j));
        S=( j<0 ? s.substring(i) : s.substring(i,j) );
                
        i=(j<0 ? s.length() : j+1); // i всегда теперь указывает на следующую строчку или в конец файла, если следующей строчки нет
        S=nocomments(S); S.replace("\t"," "); S.replace("\r",""); S.trim(); if(S=="") continue;

        ANS=DOMOTO(S);
       
        // ---
        if(ANS!="") {
          cmd=ARG(ANS,0);
          other=ARG_OTHER(ANS,0); // аргумент до конца строки
          if(ARG(ANS,1)=="{") { j=i+jsearch(s.substring(i)); other=s.substring(i,j); i=j+1; } // аргумент в фигурных скобках

          if(cmd=="FALSE") { IF=0; continue; }
          if(cmd=="TRUE" || (cmd=="else" && !IF) ) { String o=MOTO(other); if(o!="") return o; IF=1; continue; }

          if(cmd=="LOOP") { // LOOP [повтор7 номер1 секунд30 ВЫПОЛНЕНИЕ]
            uint16_t one=PARG0(other,0);
            uint32_t cikl=PARG0(other,1);
            uint32_t value=PARG0(other,2);
              if(cikl && cikl<NLOOP && value){ // это было с указанием номера цикла
                
                  Loopes[cikl].count=0;
                  Loopes[cikl].value=value;
                  Loopes[cikl].one=one;
                  Loopes[cikl].file=ARG_OTHER(other,2);
                  
                  LOG("SetLoop #["+String(cikl)+"] one=["+String(one)+"] value=["+String(value)+"] file=["+ARG_OTHER(other,2)+"]");
                  continue;
              }

          value=cikl;
          String file=ARG_OTHER(other,1); // тело скрипта
            
            uint8_t ii=255; for(uint8_t ui=0;ui<NLOOP;ui++) {
              if(Loopes[ui].file=="" && ii!=255 ) break; // найден первый же пустой цикл, не крутить
              if(ii==255 && Loopes[ui].value==0) ii=ui; // поиск свободного места
            }
                // if(ii==254) continue;
                if(ii==255) { ERR("LOOP: no room"); continue; }

                LOG("SetLoop new ii=["+String(ii)+"] one=["+String(one)+"] value=["+String(value)+"] file=["+file+"]");
                
                Loopes[ii].count=0;
                Loopes[ii].file=file;
                Loopes[ii].value=value;
                Loopes[ii].one=one;
                
                continue;
          }

          if(cmd=="LOOPFILE") { CFSET("MAINLOOP",other); continue; }
          
          if(cmd=="FTSAVE") { other.replace("\\n","\n"); cmd="FSAVE"; }
          if(cmd=="FTSAVE+") { other.replace("\\n","\n"); cmd="FSAVE+"; }
          if(cmd=="FSAVE") {
              String file=PARG(other,0); if(ARG(other,1)=="{") { j=i+jsearch(s.substring(i)); other=s.substring(i,j); i=j+1; }
              iecho(savefile(file,other)?"OK":"ERROR"); continue;
          }
          if(cmd=="FSAVE+") {
            String file=PARG(other,0); if(ARG(other,1)=="{") { j=i+jsearch(s.substring(i)); other=s.substring(i,j); i=j+1; }
              iecho(savefile(file,other,"a+")?"OK":"ERROR"); continue;
          }

          if(cmd=="repeat") {
              uint16_t rep=PARG0(ANS,1); if(!rep) { ERR("REPEAT",other); continue; }
              other=ARG_OTHER(ANS,1); if(ARG(ANS,2)=="{") { j=i+jsearch(s.substring(i)); other=s.substring(i,j); i=j+1; }
              for(int16_t l=0;l<rep;l++) { String o=MOTO(other); if(o=="break") break; if(o!="") return o; }
              // IF=1;
              continue;
          }

          if(cmd=="exit"||cmd=="stop"||cmd=="break") return cmd; // завершить выполнение

        }
        // ---
  }
  return "";
}

// DOMOTO

uint16_t findkey(String S,String code) { // найти строку по первому слову, вернуть указатель
    uint16_t len=S.length();
    uint16_t len2;
    while(S.length()) {
      len2=S.length();
      String c=ARG(S,0,"\n");
      S=S.substring(c.length()+1);
      if(c=="" || code!=ARG(c,0," ")) continue;
      return len-len2;
    }
    return 0xFFFF;
}

uint16_t findstring(String S,String code) { // найти заданную строку, вернуть указатель на нее
    uint16_t len=S.length();
    uint16_t len2;
    while(S.length()) {
      len2=S.length();
      String c=ARG(S,0,"\n");
      S=S.substring(c.length()+1);
      if(code!=c) continue;
      return len-len2;
    }
    return 0xFFFF;
}

bool PARGB(String s, int i, bool def) { 
  String c=PARG(s,i); c.toUpperCase();
  if(c=="") return def;
  if(c=="YES" || c=="TRUE") return true;
  if(c=="NO" || c=="FALSE" || c=="STOP") return false;
  return (c.toInt()?true:false);
}
bool PARGB(String s, int i) { return PARGB(s,i,false); }


String PARG(String s,int n,String sep) { return REPER(ARG(s,n,sep)); }
String PARG(String s,int n) { return PARG(s,n," "); }

int PARG0(String s,int n,String sep) { String c=PARG(s,n,sep); return (c.indexOf("{") < 0 ? c.toInt() : 0); }
int PARG0(String s,int n) { return PARG0(s,n," "); }

double DPARG0(String s,int n,String sep) { String c=PARG(s,n,sep); return (c.indexOf("{") < 0 ? c.toDouble() : 0); }
double DPARG0(String s,int n) { return DPARG0(s,n," "); }

String ARG(String s,int n,String sep) { int i=0;for(int j=0;j<n;j++) { i=s.indexOf(sep,i)+1; if(i<=0) return ""; } return s.substring(i,s.indexOf(sep,i)); }
String ARG(String s,int n) { return ARG(s,n," "); }

String ARG_OTHER(String s,int n,String sep) { int i=0;for(int j=0;j<=n;j++) { i=s.indexOf(sep,i)+1; if(i<=0) return ""; } return s.substring(i); }
String ARG_OTHER(String s,int n) { return ARG_OTHER(s,n," "); }

uint16_t count(String s,String c) { int16_t i=0; uint16_t k=1; while(1) { i=s.indexOf(c,i); if(i++<0) break; k++; } return k; }
uint16_t count(String s) { return count(s," "); }

String nocomments(String s) { int j=s.indexOf("#"); if(j>=0) { s=s.substring(0,j); s.trim(); } return s; }

bool CFSET(String n,String v) { if(n=="") return Serial.println("Error CFSET #0 var=["+v+"]");
    for(uint8_t i=0;i<NSET;i++) {
      if(Settes[i].n=="") { Settes[i].n=n; Settes[i].v=v; return 1; } // если найдена свободная ячейка
      if(Settes[i].n==n) { Settes[i].v=v; return 1; } // если найдено это имя
    }
    Serial.println("Error SET: no room");
    return 1;
}

String CF(String v,String D) { if(v=="") { Serial.println("Error CF #0 var=["+D+"]"); return ""; }
    for(uint8_t i=0;i<NSET;i++) {
      if(Settes[i].n=="") break;
      if(Settes[i].n==v) return Settes[i].v;
    } return D;
}

/// char* CFs(String v) { return CF(v,"").c_str(); }
int CF0(String v,int D) { String c=CF(v,""); c.toUpperCase(); if(c=="NO"||c=="") c="0"; else if(c=="YES"||c=="TRUE") c="1"; return (c==""?D:c.toInt()); }
String CF(String v) { return CF(v,""); }
int CF0(String v) { return CF0(v,0); }
double DCF0(String v) { return CF(v,"").toDouble(); }
// =============================================

bool inList(String file,String list) { String s,l;
      s=CF(list,"FaLsE"); if(s=="") return 0;
      if(s=="FaLsE") { s=getfile(list); CFSET(list,s); }
      file=Slash(file);
      int i=0; while(1) {
          l=ARG(s,i++,"\n"); if(l=="") return 0;
          if(file.startsWith(l)) { Serial.println("Deprecated "+file+" in ["+list+"]"); return 1; }
      } return 0;
}

bool upgrade_url(String file) { if(!WiFi.isConnected()) return false; // если нет подключения к сети
     if(inList(file,"stoplist.txt")) return 0;
    t_httpUpdate_return ret;
    Serial.println("Update new sketch "+file);
  
    ESPhttpUpdate.rebootOnUpdate(true);
    ret = ESPhttpUpdate.update(file);

       switch(ret) {
          case HTTP_UPDATE_FAILED: {
              String err=ESPhttpUpdate.getLastErrorString();
              if(err.indexOf("reset")>=0) { idip("Press RESET and repeat!"); ESP.reset(); break; }
              idip("UPDATE ERROR ["+file+"]: "+err);
              break;
          }
          case HTTP_UPDATE_NO_UPDATES: idip("HTTP_UPDATE_NO_UPDATES"); break;
          case HTTP_UPDATE_OK: idip("HTTP_UPDATE_OK"); break;
          default: idip("OTHER"); break;
      }
}

bool UpgradeALL() { if(!WiFi.isConnected()) return false; // если нет подключения к сети
    String upd=CF("server_update"); if(upd=="") return 0; upd=REPER(upd);
    String otv=file_get_contents(upd,3000); if(ARG(otv,0,"\n")!="OK") return false;

    String firmware_md5="";
    bool ResetNeed=0;
    int i=1; while(1) {
          String s=ARG(otv,i++,"\n"); if(s=="") break;
          String file=ARG(s,0," ");
          if(inList(file,"stoplist.txt")) continue;
          String md5=ARG(s,1," ");
          if(file=="firmware.bin") { firmware_md5=md5; continue; }
          if(MD5file(file)==md5) continue;
            Serial.print("UPDATE "+file+": ");
            // SYSP("play LS");
          int i=file_upload_binary(upd+"&file="+file,file);
            Serial.print(" => ");
          if(!i && MD5file(file)==md5) {
             Serial.println("OK");
             SYSP("play FFMM");
              if(file=="config.txt") ResetNeed=1;
          } else {
            Serial.println("\nERRORe #"+String(i)+" ["+upd+"&file="+file+"]");
            SYSP("DRMDRD");
          }
        }
     if(firmware_md5 != "" && firmware_md5 != ESP.getSketchMD5() ) {
        Serial.println("firmware.bin need to UPDATE"); 
        SYSP("mmmrdCL.LdCLSLMRM");
        upgrade_url(upd+"&file=firmware.bin");
     }
     if(ResetNeed) {
        Serial.print("\n\nRESET NEED...\n");
         SYSP("dSdSdCC");
        ESP.reset(); }
     return true;
}


void SYSP(String s) { if(soundpin!=255) DOMOTO("play "+s); }

bool AD() { return CF("passhash")=="" || WEB.header("Cookie").indexOf("ESP="+CF("passhash"))>=0 ; }
bool AD(bool i) { byte a=AD(); if(a) return a; otprav(i==0?"ERROR: Admin Only":"salert('You are not admin',3000);"); }

String noSlash(String s) { return ( s.startsWith("/") ? s.substring(1) : s ); }
String Slash(String s) { return ( s.startsWith("/") ? s: "/"+s); }

// ===========================

bool WIFItryConnect(String ssid,String pass) {

// Serial.printf("\n   WiFi.getMode(): %d\n", WiFi.getMode());
//    WiFi.mode(m): set mode to WIFI_AP, WIFI_STA, WIFI_AP_STA or WIFI_OFF

  Serial.print("Try connecting to: "+ssid+" ");
  
  WiFi.begin(ssid.c_str(),pass.c_str());

  byte w;

  for(uint8_t i=0;i<20;i++) {
    Serial.print(".");
    delay(500);
    w=WiFi.status();
    if(w == WL_CONNECTED) { Serial.println("Connected \"" +ssid+ "\" IP: " + WiFi.localIP().toString() ); return 1; }
    else if(w == WL_IDLE_STATUS) Serial.println(F("\n WiFi is in process of changing between statuses"));
    else if(w == WL_NO_SSID_AVAIL) Serial.println(F("\n SSID cannot be reached"));
    else if(w == WL_CONNECT_FAILED) Serial.println(F("\n password is incorrect"));
    // else if(w == WL_DISCONNECTED) Serial.println(F("\n module is not configured in station mode"));
  }

  Serial.println(" ERROR connect to \"" +ssid+ "\"" );
  return 0;
}


bool WIFIinit() {
  Serial.println("\n================= WIFIinit()");
//  WiFi.disconnect(true);
//  delay(1000);

  // http://wikihandbk.com/wiki/ESP8266:%D0%9F%D1%80%D0%BE%D1%88%D0%B8%D0%B2%D0%BA%D0%B8/Arduino/%D0%91%D0%B8%D0%B1%D0%BB%D0%B8%D0%BE%D1%82%D0%B5%D0%BA%D0%B8/%D0%91%D0%B8%D0%B1%D0%BB%D0%B8%D0%BE%D1%82%D0%B5%D0%BA%D0%B0_ESP8266WiFi/%D0%9A%D0%BB%D0%B0%D1%81%D1%81_%D1%81%D1%82%D0%B0%D0%BD%D1%86%D0%B8%D0%B8#.D0.A3.D0.BF.D1.80.D0.B0.D0.B2.D0.BB.D0.B5.D0.BD.D0.B8.D0.B5_.D0.BF.D0.BE.D0.B4.D0.BA.D0.BB.D1.8E.D1.87.D0.B5.D0.BD.D0.B8.D0.B5.D0.BC

  WiFi.disconnect();
  WiFi.softAPdisconnect(true);

  WiFi.onEvent(WiFiEvent); // да нафиг надо
  WiFi.mode(WIFI_AP_STA);
  WiFi.setAutoConnect(true);
  WiFi.persistent(false); // надо ли так?

  // по-любому создать свою точку доступа
  String AP_name=REPER(CF("AP_name"));
  String AP_password=REPER(CF("AP_password"));
  // String AP_mask=CF("AP_mask");
  // String AP_ip=CF("AP_ip");
  Serial.println("Create WiFi-network '"+AP_name+"' password: '"+AP_password+"'"); // : IP:"+AP_ip+" MASK:"+AP_mask);

  if(AP_password!="") WiFi.softAP(AP_name.c_str(),AP_password.c_str()); else WiFi.softAP(AP_name.c_str());

  WiFi.hostname(AP_name);
    // WiFi.softAPConfig(apIP,apIP,IPAddress(255,255,255,0));
  delay(500); // Without delay I've seen the IP address blank
  Serial.println("Connected: "+WiFi.softAPIP().toString() );

  DNSstart=1;
  DNS.setErrorReplyCode(DNSReplyCode::NoError);
  DNS.start(53,"*",WiFi.softAPIP());

  // перепробовать все известные нам сети
  String s=getfile("wifi_last.txt");
  if(s!="") { int i=s.indexOf("\n"); if(WIFItryConnect(s.substring(0,i++),s.substring(i))) Serial.println("Connect: "+s); }
  else if(WIFItryConnect("wifitest","kukukuku")) Serial.println("Connect TEST");

  return 0;
}

void WiFiEvent(WiFiEvent_t event) { CFSET("WIFI.event",String(event));
// DOMOTO("/WIFIevent");

    if(event == 7) return;
    if(event == WIFI_EVENT_STAMODE_GOT_IP) { Serial.println("\n[3] WiFi got IP: "+WiFi.localIP().toString()); }
    else if(event == WIFI_EVENT_STAMODE_DISCONNECTED) Serial.println(F("\n[1] WiFi lost"));
    else if(event == WIFI_EVENT_STAMODE_CONNECTED         ) Serial.println(F("\n0 - STAMODE_CONNECTED"));
    else if(event == WIFI_EVENT_STAMODE_AUTHMODE_CHANGE   ) Serial.println(F("\n2 - STAMODE_AUTHMODE_CHANGE"));
    else if(event == WIFI_EVENT_STAMODE_DHCP_TIMEOUT      ) Serial.println(F("\n4 - STAMODE_DHCP_TIMEOUT"));
    else if(event == WIFI_EVENT_SOFTAPMODE_STACONNECTED   ) Serial.println(F("\n5 - SOFTAPMODE_STACONNECTED"));
    else if(event == WIFI_EVENT_SOFTAPMODE_STADISCONNECTED) Serial.println(F("\n6 - SOFTAPMODE_STADISCONNECTED"));
    else if(event == WIFI_EVENT_SOFTAPMODE_PROBEREQRECVED ) Serial.println(F("\n7 - SOFTAPMODE_PROBEREQRECVED"));
    else if(event == WIFI_EVENT_MAX                       ) Serial.println(F("\n8 - MAX"));
    else Serial.println("\nWiFi unknown event ["+String(event)+"]");

}

void handleFileUpload() {
 if(!AD(1)) { UploadResult="ADMIN ONLY"; Serial.println("NOT ADMIN"); return; }
 if(WEB.uri() != "/upload") return;

 HTTPUpload& upload = WEB.upload();

 if(upload.status == UPLOAD_FILE_START) { // 0
    UploadResult="START";
    String filename = Slash(upload.filename);
    Serial.println("START ["+filename+"]"); fsUploadFile = SPIFFS.open(filename, "w");
    filename = String();

 } else if (upload.status == UPLOAD_FILE_WRITE) {
    Serial.print(".");
    if(fsUploadFile) fsUploadFile.write(upload.buf,upload.currentSize);

 } else if (upload.status == UPLOAD_FILE_END) {
  
    Serial.print("\nEND ["+WEB.uri()+"]totalSize: "+String(upload.totalSize)+" - ");
    if(fsUploadFile) { UploadResult="OK"; fsUploadFile.close(); }
    else UploadResult="ERR";
    Serial.println(UploadResult);
  
 } else { UploadResult="ERROR"; Serial.println(F("UPLOAD - UNKNOWN")); }
}

void iecho(String s) { // LOG("iecho: ["+s+"]");
  // s.replace("\\n","\n");
  if(EchoMOTO.length()!=0 && (EchoMOTO.length()+s.length())<4000) EchoMOTO+=s; }

// void iechoi(uint16_t i) { iecho("["+String(Buf[i].A0)+","+String(Buf[i].kn)+"],"); }

void LOG(String s) { yield(); s.replace("\n","\\n"); Serial.println("log: --> "+s); }
void ERR(String s) { s.replace("\n","\\n"); Serial.println("ERROR: ============> "+s); }
void ERR(String s,String o) { ERR(s+" ["+o+"]"); }
String NNEXT(String s,uint16_t i) { s=(s+"####END####").substring(i,i+10); s.replace("\n","\\n"); return " NEXT("+s+"...)"; }
